
#cs

Assumption1: no line breaks or tabs within fields
Assumption2: same number of fields per record

TRES CSV2WFTM v0.1 by Samuel Murray

#ce

MsgBox (0, "TRES CSV2WFTM v0.1 by Samuel Murray", "This script assumes that there are no line breaks within fields and that all extractable records have 5 fields.  This is generally true for most TRES CSV files, I think.  Records with more or less fields are written to an error file, for you to look at." & @CRLF & @CRLF & "The script will process all CSV files in the current folder and all subfolders, but not in any predictable order.  The script attempts to convert doubled quotes to real quotes and to remove superfluous quotes, but it's all based on assumptions, assumptions." & @CRLF & @CRLF & "You'll know when the script is finished when its icon disappears from the systray.", 0)

$attr = MsgBox (4, "Merge fields 3, 4 and 5 into single attribute?", "Should fields 3, 4 and 5 be merged into a single attribute?  If you say 'No', it will be three separate attributes in the WF TM", 0)

$filetype = "CSV"
$filelist =  _GetFilesFolder_Rekursiv(@ScriptDir, $filetype, 0, 0)

$slang = InputBox ("SL code", "Source language code", "EN-US")
$tlang = InputBox ("TL code", "Target language code", "AF-ZA")

$bigfilename = FileSaveDialog ("Save final WF TM to which file?", @ScriptDir, "Text files (*.txt)|All (*.*)", 18, "WFTM.txt")

$errorfilename = FileSaveDialog ("Write non-conformant lines to which file?", @ScriptDir, "Text files (*.txt)|All (*.*)", 18, "errors.txt")

$bigfile = FileOpen ($bigfilename, 33)
$errorfile = FileOpen ($errorfilename, 33)

FileWrite ($bigfile, "%20160620~120101" & @TAB & "%TRES" & @TAB & "%TU=00000000" & @TAB & "%" & $slang & @TAB & "%Wordfast translation memory version v.5" & @TAB & "%" & $tlang & @TAB & "%This is a header - do not delete, move or sort." & @CRLF)

For $i = 1 to $filelist[0]

$fileopen = FileOpen ($filelist[$i], 32)
$fileread = FileRead ($fileopen)

$fileread = StringReplace ($fileread, @CRLF & '"""', @CRLF & '"{{QUOT}}')
$fileread = StringReplace ($fileread, '"""' & @CRLF, '{{QUOT}}"' & @CRLF)

$fileread = StringReplace ($fileread, @TAB & '"""', @TAB & '"{{QUOT}}')
$fileread = StringReplace ($fileread, '"""' & @TAB, '{{QUOT}}"' & @TAB)

$fileread = StringReplace ($fileread, '""', '{{QUOT}}')
$fileread = StringReplace ($fileread, '"', '')
$fileread = StringReplace ($fileread, '{{QUOT}}', '"')

$firstsplit = StringSplit ($fileread, @CRLF, 1)

For $j = 1 to $firstsplit[0]

$secondsplit = StringSplit ($firstsplit[$j], @TAB, 1)

If @error = 1 Then
ContinueLoop
EndIf

If $secondsplit[0] = 5 Then

If $attr = 6 Then ; then yes
FileWrite ($bigfile, "20160620~120102" & @TAB & "TRES" & @TAB & "0" & @TAB & $slang & @TAB & $secondsplit[1] & @TAB & $tlang & @TAB & $secondsplit[2] & @TAB & $secondsplit[3] & "|" & $secondsplit[4] & "|" & $secondsplit[5] & @CRLF)
Else ; then no
FileWrite ($bigfile, "20160620~120102" & @TAB & "TRES" & @TAB & "0" & @TAB & $slang & @TAB & $secondsplit[1] & @TAB & $tlang & @TAB & $secondsplit[2] & @TAB & $secondsplit[3] & @TAB & $secondsplit[4] & @TAB & $secondsplit[5] & @CRLF)
EndIf

ElseIf $secondsplit[0] = 6 Then

If $attr = 6 Then ; then yes
FileWrite ($bigfile, "20160620~120102" & @TAB & "TRES" & @TAB & "0" & @TAB & $slang & @TAB & $secondsplit[1] & @TAB & $tlang & @TAB & $secondsplit[2] & @TAB & $secondsplit[3] & "|" & $secondsplit[4] & "|" & $secondsplit[5] & "|" & $secondsplit[6] & @CRLF)
Else ; then no
FileWrite ($bigfile, "20160620~120102" & @TAB & "TRES" & @TAB & "0" & @TAB & $slang & @TAB & $secondsplit[1] & @TAB & $tlang & @TAB & $secondsplit[2] & @TAB & $secondsplit[3] & @TAB & $secondsplit[4] & @TAB & $secondsplit[5] & @CRLF & $secondsplit[6] & @CRLF)
EndIf

Else

FileWrite ($errorfile, $firstsplit[$j] & @CRLF)

EndIf

Next

Next

; ==


;======================================================================================
; Function Name:   _GetFilesFolder_Rekursiv($sPath [, $sExt='*' [, $iDir=-1 [, $iRetType=0 ,[$sDelim='0']]]])
; Description:     recursive listing of files and/or folders
; Parameter(s):    $sPath     Basicpath of listing ('.' -current path, '..' -parent path)
;                  $sExt      Extension for file selection '*' or -1 for all (Default)
;                  $iDir      -1 files+Folder(Default), 0 only files, 1 only Folder
;      optional:   $iRetType  0 for Array, 1 for String as Return
;      optional:   $sDelim    Delimiter for string return
;                             0 -@CRLF (Default)  1 -@CR  2 -@LF  3 -';'  4 -'|'
; Return Value(s): Array (Default) or string with found pathes of files and/or folder
;                  Array[0] includes count of found files/folder
; Author(s):       BugFix (bugfix@autoit.de)
;=====================================================================================

Func _GetFilesFolder_Rekursiv($sPath, $sExt='*', $iDir=-1, $iRetType=0, $sDelim='0')
    Global $oFSO = ObjCreate('Scripting.FileSystemObject')
    Global $strFiles = ''
    Switch $sDelim
        Case '1'
            $sDelim = @CR
        Case '2'
            $sDelim = @LF
        Case '3'
            $sDelim = ';'
        Case '4'
            $sDelim = '|'
        Case Else
            $sDelim = @CRLF
    EndSwitch
    If ($iRetType < 0) Or ($iRetType > 1) Then $iRetType = 0
    If $sExt = -1 Then $sExt = '*'
    If ($iDir < -1) Or ($iDir > 1) Then $iDir = -1
    _ShowSubFolders($oFSO.GetFolder($sPath),$sExt,$iDir,$sDelim)
    If $iRetType = 0 Then
        Local $aOut
        $aOut = StringSplit(StringTrimRight($strFiles, StringLen($sDelim)), $sDelim, 1)
        If $aOut[1] = '' Then
            ReDim $aOut[1]
            $aOut[0] = 0
        EndIf
        Return $aOut
    Else
        Return StringTrimRight($strFiles, StringLen($sDelim))
    EndIf
EndFunc

Func _ShowSubFolders($Folder, $Ext='*', $Dir=-1, $Delim=@CRLF)
    If Not IsDeclared("strFiles") Then Global $strFiles = ''
    If ($Dir = -1) Or ($Dir = 0) Then
        For $file In $Folder.Files
            If $Ext <> '*' Then
                If StringRight($file.Name, StringLen($Ext)) = $Ext Then _
                    $strFiles &= $file.Path & $Delim
            Else
                $strFiles &= $file.Path & $Delim
            EndIf
        Next
    EndIf
    For $Subfolder In $Folder.SubFolders
        If ($Dir = -1) Or ($Dir = 1) Then $strFiles &= $Subfolder.Path & '\' & $Delim
        _ShowSubFolders($Subfolder, $Ext, $Dir, $Delim)
    Next
EndFunc
 